Index: /BAORadio/libindi/libindi/libs/indibase/indiccd.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indiccd.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/libs/indibase/indiccd.cpp	(revision 697)
@@ -162,15 +162,15 @@
     HasSt4Port=false;
     InExposure=false;
-    TelescopeTP = new ITextVectorProperty;
+    ActiveDeviceTP = new ITextVectorProperty;
 }
 
 INDI::CCD::~CCD()
 {
-    delete TelescopeTP;
+    delete ActiveDeviceTP;
 }
 
 bool INDI::CCD::initProperties()
 {
-    DefaultDriver::initProperties();   //  let the base class flesh in what it wants
+    DefaultDevice::initProperties();   //  let the base class flesh in what it wants
 
     // PRIMARY CCD Init
@@ -180,5 +180,5 @@
     IUFillNumber(&PrimaryCCD.ImageFrameN[2],"WIDTH","Width","%4.0f",0,1392.0,0,1392.0);
     IUFillNumber(&PrimaryCCD.ImageFrameN[3],"HEIGHT","Height","%4.0f",0,1040,0,1040);
-    IUFillNumberVector(PrimaryCCD.ImageFrameNP,PrimaryCCD.ImageFrameN,4,deviceName(),"CCD_FRAME","Frame",IMAGE_SETTINGS_TAB,IP_RW,60,IPS_IDLE);
+    IUFillNumberVector(PrimaryCCD.ImageFrameNP,PrimaryCCD.ImageFrameN,4,getDeviceName(),"CCD_FRAME","Frame",IMAGE_SETTINGS_TAB,IP_RW,60,IPS_IDLE);
 
     IUFillSwitch(&PrimaryCCD.FrameTypeS[0],"FRAME_LIGHT","Light",ISS_ON);
@@ -186,12 +186,12 @@
     IUFillSwitch(&PrimaryCCD.FrameTypeS[2],"FRAME_DARK","Dark",ISS_OFF);
     IUFillSwitch(&PrimaryCCD.FrameTypeS[3],"FRAME_FLAT","Flat",ISS_OFF);
-    IUFillSwitchVector(PrimaryCCD.FrameTypeSP,PrimaryCCD.FrameTypeS,4,deviceName(),"CCD_FRAME_TYPE","FrameType",IMAGE_SETTINGS_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
+    IUFillSwitchVector(PrimaryCCD.FrameTypeSP,PrimaryCCD.FrameTypeS,4,getDeviceName(),"CCD_FRAME_TYPE","FrameType",IMAGE_SETTINGS_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
 
     IUFillNumber(&PrimaryCCD.ImageExposureN[0],"CCD_EXPOSURE_VALUE","Duration (s)","%5.2f",0,36000,0,1.0);
-    IUFillNumberVector(PrimaryCCD.ImageExposureNP,PrimaryCCD.ImageExposureN,1,deviceName(),"CCD_EXPOSURE_REQUEST","Expose",MAIN_CONTROL_TAB,IP_RW,60,IPS_IDLE);
+    IUFillNumberVector(PrimaryCCD.ImageExposureNP,PrimaryCCD.ImageExposureN,1,getDeviceName(),"CCD_EXPOSURE_REQUEST","Expose",MAIN_CONTROL_TAB,IP_RW,60,IPS_IDLE);
 
     IUFillNumber(&PrimaryCCD.ImageBinN[0],"HOR_BIN","X","%2.0f",1,4,1,1);
     IUFillNumber(&PrimaryCCD.ImageBinN[1],"VER_BIN","Y","%2.0f",1,4,1,1);
-    IUFillNumberVector(PrimaryCCD.ImageBinNP,PrimaryCCD.ImageBinN,2,deviceName(),"CCD_BINNING","Binning",IMAGE_SETTINGS_TAB,IP_RW,60,IPS_IDLE);
+    IUFillNumberVector(PrimaryCCD.ImageBinNP,PrimaryCCD.ImageBinN,2,getDeviceName(),"CCD_BINNING","Binning",IMAGE_SETTINGS_TAB,IP_RW,60,IPS_IDLE);
 
     IUFillNumber(&PrimaryCCD.ImagePixelSizeN[0],"CCD_MAX_X","Resolution x","%4.0f",1,40,0,6.45);
@@ -201,12 +201,12 @@
     IUFillNumber(&PrimaryCCD.ImagePixelSizeN[4],"CCD_PIXEL_SIZE_Y","Pixel size Y","%5.2f",1,40,0,6.45);
     IUFillNumber(&PrimaryCCD.ImagePixelSizeN[5],"CCD_BITSPERPIXEL","Bits per pixel","%3.0f",1,40,0,6.45);
-    IUFillNumberVector(PrimaryCCD.ImagePixelSizeNP,PrimaryCCD.ImagePixelSizeN,6,deviceName(),"CCD_INFO","Ccd Information",IMAGE_INFO_TAB,IP_RO,60,IPS_IDLE);
+    IUFillNumberVector(PrimaryCCD.ImagePixelSizeNP,PrimaryCCD.ImagePixelSizeN,6,getDeviceName(),"CCD_INFO","Ccd Information",IMAGE_INFO_TAB,IP_RO,60,IPS_IDLE);
 
     IUFillSwitch(&PrimaryCCD.CompressS[0],"COMPRESS","Compress",ISS_OFF);
     IUFillSwitch(&PrimaryCCD.CompressS[1],"RAW","Raw",ISS_ON);
-    IUFillSwitchVector(PrimaryCCD.CompressSP,PrimaryCCD.CompressS,2,deviceName(),"COMPRESSION","Image",IMAGE_SETTINGS_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
+    IUFillSwitchVector(PrimaryCCD.CompressSP,PrimaryCCD.CompressS,2,getDeviceName(),"COMPRESSION","Image",IMAGE_SETTINGS_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
 
     IUFillBLOB(&PrimaryCCD.FitsB,"CCD1","Image","");
-    IUFillBLOBVector(PrimaryCCD.FitsBP,&PrimaryCCD.FitsB,1,deviceName(),"CCD1","Image Data",OPTIONS_TAB,IP_RO,60,IPS_IDLE);
+    IUFillBLOBVector(PrimaryCCD.FitsBP,&PrimaryCCD.FitsB,1,getDeviceName(),"CCD1","Image Data",OPTIONS_TAB,IP_RO,60,IPS_IDLE);
 
     // GUIDER CCD Init
@@ -216,5 +216,5 @@
     IUFillNumber(&GuideCCD.ImageFrameN[2],"WIDTH","Width","%4.0f",0,1392.0,0,1392.0);
     IUFillNumber(&GuideCCD.ImageFrameN[3],"HEIGHT","Height","%4.0f",0,1040,0,1040);
-    IUFillNumberVector(GuideCCD.ImageFrameNP,GuideCCD.ImageFrameN,4,deviceName(),"GUIDE_FRAME","Frame",GUIDE_HEAD_TAB,IP_RW,60,IPS_IDLE);
+    IUFillNumberVector(GuideCCD.ImageFrameNP,GuideCCD.ImageFrameN,4,getDeviceName(),"GUIDE_FRAME","Frame",GUIDE_HEAD_TAB,IP_RW,60,IPS_IDLE);
 
     IUFillNumber(&GuideCCD.ImagePixelSizeN[0],"Image_MAX_X","Resolution x","%4.0f",1,40,0,6.45);
@@ -224,27 +224,33 @@
     IUFillNumber(&GuideCCD.ImagePixelSizeN[4],"Image_PIXEL_SIZE_Y","Pixel size Y","%5.2f",1,40,0,6.45);
     IUFillNumber(&GuideCCD.ImagePixelSizeN[5],"Image_BITSPERPIXEL","Bits per pixel","%3.0f",1,40,0,6.45);
-    IUFillNumberVector(GuideCCD.ImagePixelSizeNP,GuideCCD.ImagePixelSizeN,6,deviceName(),"GUIDE_INFO",GUIDE_HEAD_TAB,GUIDE_HEAD_TAB,IP_RO,60,IPS_IDLE);
+    IUFillNumberVector(GuideCCD.ImagePixelSizeNP,GuideCCD.ImagePixelSizeN,6,getDeviceName(),"GUIDE_INFO",GUIDE_HEAD_TAB,GUIDE_HEAD_TAB,IP_RO,60,IPS_IDLE);
 
     IUFillNumber(&GuideCCD.ImageExposureN[0],"GUIDER_EXPOSURE_VALUE","Duration (s)","%5.2f",0,36000,0,1.0);
-    IUFillNumberVector(GuideCCD.ImageExposureNP,GuideCCD.ImageExposureN,1,deviceName(),"GUIDER_EXPOSURE","Image",MAIN_CONTROL_TAB,IP_RW,60,IPS_IDLE);
+    IUFillNumberVector(GuideCCD.ImageExposureNP,GuideCCD.ImageExposureN,1,getDeviceName(),"GUIDER_EXPOSURE","Image",MAIN_CONTROL_TAB,IP_RW,60,IPS_IDLE);
 
     IUFillSwitch(&GuideCCD.CompressS[0],"GCOMPRESS","Compress",ISS_OFF);
     IUFillSwitch(&GuideCCD.CompressS[1],"GRAW","Raw",ISS_ON);
-    IUFillSwitchVector(GuideCCD.CompressSP,GuideCCD.CompressS,2,deviceName(),"GCOMPRESSION","Image",GUIDE_HEAD_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
+    IUFillSwitchVector(GuideCCD.CompressSP,GuideCCD.CompressS,2,getDeviceName(),"GCOMPRESSION","Image",GUIDE_HEAD_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
 
     IUFillBLOB(&GuideCCD.FitsB,"CCD2","Guider Image","");
-    IUFillBLOBVector(GuideCCD.FitsBP,&GuideCCD.FitsB,1,deviceName(),"CCD2","Image Data",OPTIONS_TAB,IP_RO,60,IPS_IDLE);
+    IUFillBLOBVector(GuideCCD.FitsBP,&GuideCCD.FitsB,1,getDeviceName(),"CCD2","Image Data",OPTIONS_TAB,IP_RO,60,IPS_IDLE);
 
     // CCD Class Init
 
-    IUFillText(&TelescopeT[0],"ACTIVE_TELESCOPE","Telescope","");
-    IUFillTextVector(TelescopeTP,TelescopeT,1,deviceName(),"ACTIVE_DEVICES","Snoop Scope",OPTIONS_TAB,IP_RW,60,IPS_IDLE);
+    IUFillText(&ActiveDeviceT[0],"ACTIVE_TELESCOPE","Telescope","Telescope Simulator");
+    IUFillText(&ActiveDeviceT[1],"ACTIVE_FOCUSER","Focuser","Focuser Simulator");
+    IUFillTextVector(ActiveDeviceTP,ActiveDeviceT,2,getDeviceName(),"ACTIVE_DEVICES","Snoop devices",OPTIONS_TAB,IP_RW,60,IPS_IDLE);
 
     IUFillNumber(&EqN[0],"RA_PEC","Ra (hh:mm:ss)","%010.6m",0,24,0,0);
     IUFillNumber(&EqN[1],"DEC_PEC","Dec (dd:mm:ss)","%010.6m",-90,90,0,0);
-    IUFillNumberVector(&EqNP,EqN,2,"","EQUATORIAL_PEC","EQ PEC","Main Control",IP_RW,60,IPS_IDLE);
+    IUFillNumberVector(&EqNP,EqN,2,ActiveDeviceT[0].text,"EQUATORIAL_PEC","EQ PEC","Main Control",IP_RW,60,IPS_IDLE);
+
+    IDSnoopDevice(ActiveDeviceT[0].text,"EQUATORIAL_PEC");
+    IDSnoopDevice(ActiveDeviceT[0].text,"TELESCOPE_PARAMETERS");
+    IDSnoopDevice(ActiveDeviceT[1].text,"FWHM");
+
 
     // Guider Interface
-    initGuiderProperties(deviceName(), GUIDE_CONTROL_TAB);
+    initGuiderProperties(getDeviceName(), GUIDE_CONTROL_TAB);
 
     return true;
@@ -257,5 +263,5 @@
     //IDLog("INDI::CCD IsGetProperties with %s\n",dev);
 
-    DefaultDriver::ISGetProperties(dev);
+    DefaultDevice::ISGetProperties(dev);
 
     return;
@@ -296,5 +302,5 @@
         }
         defineSwitch(PrimaryCCD.FrameTypeSP);
-        defineText(TelescopeTP);
+        defineText(ActiveDeviceTP);
     }
     else
@@ -321,10 +327,10 @@
         }
         deleteProperty(PrimaryCCD.FrameTypeSP->name);
-        deleteProperty(TelescopeTP->name);
+        deleteProperty(ActiveDeviceTP->name);
     }
     return true;
 }
 
-void INDI::CCD::ISSnoopDevice (XMLEle *root)
+bool INDI::CCD::ISSnoopDevice (XMLEle *root)
  {
      //fprintf(stderr," ################# CCDSim handling snoop ##############\n");
@@ -346,4 +352,6 @@
         //fprintf(stderr,"Snoop Failed\n");
      }
+
+     return true;
  }
 
@@ -353,20 +361,23 @@
     //IDLog("IndiTelescope got %d new text items name %s\n",n,name);
     //  first check if it's for our device
-    if(strcmp(dev,deviceName())==0)
+    if(strcmp(dev,getDeviceName())==0)
     {
         //  This is for our device
         //  Now lets see if it's something we process here
-        if(strcmp(name,TelescopeTP->name)==0)
+        if(strcmp(name,ActiveDeviceTP->name)==0)
         {
             int rc;
             //IDLog("calling update text\n");
-            TelescopeTP->s=IPS_OK;
-            rc=IUUpdateText(TelescopeTP,texts,names,n);
+            ActiveDeviceTP->s=IPS_OK;
+            rc=IUUpdateText(ActiveDeviceTP,texts,names,n);
             //IDLog("update text returns %d\n",rc);
             //  Update client display
-            IDSetText(TelescopeTP,NULL);
+            IDSetText(ActiveDeviceTP,NULL);
             saveConfig();
-            IUFillNumberVector(&EqNP,EqN,2,TelescopeT[0].text,"EQUATORIAL_PEC","EQ PEC",MAIN_CONTROL_TAB,IP_RW,60,IPS_IDLE);
-            IDSnoopDevice(TelescopeT[0].text,"EQUATORIAL_PEC");
+            IUFillNumberVector(&EqNP,EqN,2,ActiveDeviceT[0].text,"EQUATORIAL_PEC","EQ PEC",MAIN_CONTROL_TAB,IP_RW,60,IPS_IDLE);
+
+            IDSnoopDevice(ActiveDeviceT[0].text,"EQUATORIAL_PEC");
+            IDSnoopDevice(ActiveDeviceT[0].text,"TELESCOPE_PARAMETERS");
+            IDSnoopDevice(ActiveDeviceT[1].text,"FWHM");
             //  We processed this one, so, tell the world we did it
             return true;
@@ -375,5 +386,5 @@
     }
 
-    return INDI::DefaultDriver::ISNewText(dev,name,texts,names,n);
+    return INDI::DefaultDevice::ISNewText(dev,name,texts,names,n);
 }
 
@@ -382,5 +393,5 @@
     //  first check if it's for our device
     //IDLog("INDI::CCD::ISNewNumber %s\n",name);
-    if(strcmp(dev,deviceName())==0)
+    if(strcmp(dev,getDeviceName())==0)
     {
         //  This is for our device
@@ -497,5 +508,6 @@
             //IDSetNumber(GuiderFrameNP,NULL);
 
-            IDLog("GuiderFrame set to %4.0f,%4.0f %4.0f x %4.0f\n",
+            if (isDebug())
+                IDLog("GuiderFrame set to %4.0f,%4.0f %4.0f x %4.0f\n",
                   GuideCCD.ImageFrameN[0].value,GuideCCD.ImageFrameN[1].value,GuideCCD.ImageFrameN[2].value,GuideCCD.ImageFrameN[3].value);
             //GSubX=GuiderFrameN[0].value;
@@ -517,5 +529,6 @@
             IDSetNumber(GuideNSP,NULL);
 
-            fprintf(stderr,"GuideNorthSouth set to %7.3f,%7.3f\n", GuideNS[0].value,GuideNS[1].value);
+            if (isDebug())
+                fprintf(stderr,"GuideNorthSouth set to %7.3f,%7.3f\n", GuideNS[0].value,GuideNS[1].value);
 
             if(GuideNS[0].value != 0)
@@ -542,6 +555,6 @@
             IDSetNumber(GuideEWP,NULL);
 
-            fprintf(stderr,"GuiderEastWest set to %6.3f,%6.3f\n",
-                  GuideEW[0].value,GuideEW[1].value);
+            if (isDebug())
+                fprintf(stderr,"GuiderEastWest set to %6.3f,%6.3f\n", GuideEW[0].value,GuideEW[1].value);
 
             if(GuideEW[0].value != 0)
@@ -564,5 +577,5 @@
     //  if we didn't process it, continue up the chain, let somebody else
     //  give it a shot
-    return DefaultDriver::ISNewNumber(dev,name,values,names,n);
+    return DefaultDevice::ISNewNumber(dev,name,values,names,n);
 }
 
@@ -570,5 +583,5 @@
 {
 
-    if(strcmp(dev,deviceName())==0)
+    if(strcmp(dev,getDeviceName())==0)
     {
 
@@ -623,5 +636,5 @@
 
     // let the default driver have a crack at it
-    return DefaultDriver::ISNewSwitch(dev, name, states, names, n);
+    return DefaultDevice::ISNewSwitch(dev, name, states, names, n);
 }
 
@@ -789,5 +802,5 @@
 {
     //  lets try sending a ccd preview
-    //IDLog("Enter Uploadfile with %d total sending via %s\n",total,FitsBP->name);
+
     PrimaryCCD.FitsB.blob=fitsdata;
     PrimaryCCD.FitsB.bloblen=total;
@@ -795,4 +808,5 @@
     strcpy(PrimaryCCD.FitsB.format,".fits");
     PrimaryCCD.FitsBP->s=IPS_OK;
+    //IDLog("Enter Uploadfile with %d total sending via %s, and format %s\n",total,PrimaryCCD.FitsB.name, PrimaryCCD.FitsB.format);
     IDSetBLOB(PrimaryCCD.FitsBP,NULL);
 
Index: /BAORadio/libindi/libindi/libs/indibase/indiccd.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indiccd.h	(revision 696)
+++ /BAORadio/libindi/libindi/libs/indibase/indiccd.h	(revision 697)
@@ -23,5 +23,5 @@
 #include <fitsio.h>
 
-#include "defaultdriver.h"
+#include "defaultdevice.h"
 #include "indiguiderinterface.h"
 
@@ -122,5 +122,5 @@
 \author Gerry Rozema, Jasem Mutlaq
 */
-class INDI::CCD : public INDI::DefaultDriver, INDI::GuiderInterface
+class INDI::CCD : public INDI::DefaultDevice, INDI::GuiderInterface
 {
       public:
@@ -134,5 +134,5 @@
         virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
         virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);
-        virtual void ISSnoopDevice (XMLEle *root);
+        virtual bool ISSnoopDevice (XMLEle *root);
 
      protected:
@@ -240,4 +240,10 @@
         virtual bool GuideWest(float ms);
 
+        /** \brief Add FITS keywords to a fits file
+            \param fptr pointer to a valid FITS file.
+            \note This function is not implemented in INDI::CCD, it must be implemented in the child class
+        */
+        virtual void addFITSKeywords(fitsfile *fptr);
+
         float RA;
         float Dec;
@@ -254,8 +260,7 @@
     INumber EqN[2];
 
-    ITextVectorProperty *TelescopeTP;
-    IText TelescopeT[1];
-
-    void addFITSKeywords(fitsfile *fptr);
+    ITextVectorProperty *ActiveDeviceTP;
+    IText ActiveDeviceT[2];
+
     int uploadfile(void *fitsdata,int total);
 
Index: /BAORadio/libindi/libindi/libs/indibase/indifilterinterface.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indifilterinterface.h	(revision 696)
+++ /BAORadio/libindi/libindi/libs/indibase/indifilterinterface.h	(revision 697)
@@ -53,8 +53,9 @@
     /** \brief Obtains a list of filter names from the hardware and initilizes the FilterNameTP property. The function should check for the number of filters
       available in the filter wheel and build the FilterNameTP property accordingly.
+      \param groupName group name for FilterNameTP property to be created.
       \return True if successful, false if unsupported or failed operation
       \see QSI CCD implementation of the FilterInterface. QSI CCD is available as a 3rd party INDI driver.
     */
-    virtual bool GetFilterNames(const char *deviceName, const char* groupName) = 0;
+    virtual bool GetFilterNames(const char* groupName) = 0;
 
     /** \brief The child class calls this function when the hardware successfully finished selecting a new filter wheel position
Index: /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.cpp	(revision 697)
@@ -35,7 +35,9 @@
 bool INDI::FilterWheel::initProperties()
 {
-    DefaultDriver::initProperties();
+    DefaultDevice::initProperties();
 
-    initFilterProperties(deviceName(), FILTER_TAB);
+    initFilterProperties(getDeviceName(), FILTER_TAB);
+
+    return true;
 }
 
@@ -44,10 +46,10 @@
     //  First we let our parent populate
     //IDLog("INDI::FilterWheel::ISGetProperties %s\n",dev);
-    DefaultDriver::ISGetProperties(dev);
+    DefaultDevice::ISGetProperties(dev);
     if(isConnected())
     {
         defineNumber(FilterSlotNP);
 
-        if (GetFilterNames(deviceName(), FILTER_TAB))
+        if (GetFilterNames(FILTER_TAB))
             defineText(FilterNameTP);
     }
@@ -62,7 +64,7 @@
     if(isConnected())
     {
-        initFilterProperties(deviceName(), FILTER_TAB);
+        //initFilterProperties(getDeviceName(), FILTER_TAB);
         defineNumber(FilterSlotNP);
-        if (GetFilterNames(deviceName(), FILTER_TAB))
+        if (GetFilterNames(FILTER_TAB))
             defineText(FilterNameTP);
     } else
@@ -77,5 +79,5 @@
 bool INDI::FilterWheel::ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n)
 {
-    return DefaultDriver::ISNewSwitch(dev, name, states, names,n);
+    return DefaultDevice::ISNewSwitch(dev, name, states, names,n);
 }
 
@@ -84,5 +86,5 @@
     //  first check if it's for our device
     //IDLog("INDI::FilterWheel::ISNewNumber %s\n",name);
-    if(strcmp(dev,deviceName())==0)
+    if(strcmp(dev,getDeviceName())==0)
     {
         //  This is for our device
@@ -119,5 +121,5 @@
     //  if we didn't process it, continue up the chain, let somebody else
     //  give it a shot
-    return DefaultDriver::ISNewNumber(dev,name,values,names,n);
+    return DefaultDevice::ISNewNumber(dev,name,values,names,n);
 }
 
@@ -127,5 +129,5 @@
     //IDLog("INDI::FilterWheel got %d new text items name %s\n",n,name);
     //  first check if it's for our device
-    if(strcmp(dev,deviceName())==0)
+    if(strcmp(dev,getDeviceName())==0)
     {
         //  This is for our device
@@ -151,5 +153,5 @@
     }
 
-    return DefaultDriver::ISNewText(dev,name,texts,names,n);
+    return DefaultDevice::ISNewText(dev,name,texts,names,n);
 }
 
@@ -170,13 +172,7 @@
 }
 
-void INDI::FilterWheel::ISSnoopDevice (XMLEle *root)
+
+bool INDI::FilterWheel::GetFilterNames(const char* groupName)
 {
- return;
-}
-
-
-bool INDI::FilterWheel::GetFilterNames(const char *deviceName, const char* groupName)
-{
-    INDI_UNUSED(deviceName);
     INDI_UNUSED(groupName);
     return false;
Index: /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.h	(revision 696)
+++ /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.h	(revision 697)
@@ -20,5 +20,5 @@
 #define INDI_FILTERWHEEL_H
 
-#include "defaultdriver.h"
+#include "defaultdevice.h"
 #include "indifilterinterface.h"
 
@@ -32,5 +32,5 @@
 \see INDI::FilterInterface
 */
-class INDI::FilterWheel: public INDI::DefaultDriver, public INDI::FilterInterface
+class INDI::FilterWheel: public INDI::DefaultDevice, public INDI::FilterInterface
 {
 protected:
@@ -47,5 +47,4 @@
         virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
         virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);      
-        virtual void ISSnoopDevice (XMLEle *root);
 
    protected:
@@ -54,5 +53,5 @@
     virtual bool SelectFilter(int);
     virtual bool SetFilterNames();
-    virtual bool GetFilterNames(const char *deviceName, const char* groupName);
+    virtual bool GetFilterNames(const char* groupName);
 
 };
Index: /BAORadio/libindi/libindi/libs/indibase/indifocuser.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indifocuser.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/libs/indibase/indifocuser.cpp	(revision 697)
@@ -38,15 +38,15 @@
 bool INDI::Focuser::initProperties()
 {
-    DefaultDriver::initProperties();   //  let the base class flesh in what it wants
+    DefaultDevice::initProperties();   //  let the base class flesh in what it wants
 
     IUFillNumber(&FocusSpeedN[0],"FOCUS_SPEED_VALUE","Focus Speed","%3.0f",0.0,255.0,1.0,255.0);
-    IUFillNumberVector(FocusSpeedNP,FocusSpeedN,1,deviceName(),"FOCUS_SPEED","Speed",MAIN_CONTROL_TAB,IP_RW,60,IPS_OK);
+    IUFillNumberVector(FocusSpeedNP,FocusSpeedN,1,getDeviceName(),"FOCUS_SPEED","Speed",MAIN_CONTROL_TAB,IP_RW,60,IPS_OK);
 
     IUFillNumber(&FocusTimerN[0],"FOCUS_TIMER_VALUE","Focus Timer","%4.0f",0.0,1000.0,10.0,1000.0);
-    IUFillNumberVector(FocusTimerNP,FocusTimerN,1,deviceName(),"FOCUS_TIMER","Timer",MAIN_CONTROL_TAB,IP_RW,60,IPS_OK);
+    IUFillNumberVector(FocusTimerNP,FocusTimerN,1,getDeviceName(),"FOCUS_TIMER","Timer",MAIN_CONTROL_TAB,IP_RW,60,IPS_OK);
 
     IUFillSwitch(&FocusMotionS[0],"FOCUS_INWARD","Focus In",ISS_ON);
     IUFillSwitch(&FocusMotionS[1],"FOCUS_OUTWARD","Focus Out",ISS_OFF);
-    IUFillSwitchVector(FocusMotionSP,FocusMotionS,2,deviceName(),"FOCUS_MOTION","Direction",MAIN_CONTROL_TAB,IP_RW,ISR_1OFMANY,60,IPS_OK);
+    IUFillSwitchVector(FocusMotionSP,FocusMotionS,2,getDeviceName(),"FOCUS_MOTION","Direction",MAIN_CONTROL_TAB,IP_RW,ISR_1OFMANY,60,IPS_OK);
 
     return 0;
@@ -56,5 +56,5 @@
 {
     //  First we let our parent populate
-    DefaultDriver::ISGetProperties(dev);
+    DefaultDevice::ISGetProperties(dev);
 
     return;
@@ -82,5 +82,5 @@
 {
     //  first check if it's for our device
-    if(strcmp(dev,deviceName())==0)
+    if(strcmp(dev,getDeviceName())==0)
     {
         //  This is for our device
@@ -127,5 +127,5 @@
 
 
-    return DefaultDriver::ISNewNumber(dev,name,values,names,n);
+    return DefaultDevice::ISNewNumber(dev,name,values,names,n);
 }
 
@@ -133,5 +133,5 @@
 {
 
-    if(strcmp(dev,deviceName())==0)
+    if(strcmp(dev,getDeviceName())==0)
     {
         //  This one is for us
@@ -150,15 +150,10 @@
 
     //  Nobody has claimed this, so, ignore it
-    return DefaultDriver::ISNewSwitch(dev,name,states,names,n);
+    return DefaultDevice::ISNewSwitch(dev,name,states,names,n);
 }
 
 bool INDI::Focuser::ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n)
 {
-    return DefaultDriver::ISNewText(dev, name, texts, names, n);
-}
-
-void INDI::Focuser::ISSnoopDevice (XMLEle *root)
-{
- return;
+    return DefaultDevice::ISNewText(dev, name, texts, names, n);
 }
 
@@ -172,2 +167,7 @@
 }
 
+bool INDI::Focuser::ISSnoopDevice (XMLEle *root)
+{
+    return false;
+}
+
Index: /BAORadio/libindi/libindi/libs/indibase/indifocuser.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indifocuser.h	(revision 696)
+++ /BAORadio/libindi/libindi/libs/indibase/indifocuser.h	(revision 697)
@@ -20,5 +20,5 @@
 #define INDIFOCUSSER_H
 
-#include "defaultdriver.h"
+#include "defaultdevice.h"
 
 /**
@@ -30,5 +30,5 @@
 \author Gerry Rozema
 */
-class INDI::Focuser : public INDI::DefaultDriver
+class INDI::Focuser : public INDI::DefaultDevice
 {
     public:
@@ -44,5 +44,5 @@
         virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
         virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);
-        virtual void ISSnoopDevice (XMLEle *root);
+        virtual bool ISSnoopDevice (XMLEle *root);
 
     protected:
